var frontend_url1   = "http://service.prod.roas360.com/prod-service-android/frontend/"; // "http://service.prod.roas360.com/prod/frontend/"; end slash
var frontend_url2   = "http://service.prod.roas360.net/prod-service-android/frontend/"; // "http://service.prod.roas360.net/prod/frontend/"; end slash
var handset_version = "serviceprod-575-20160115040912"; // "salesdev-503-20150520215553";
var jslogit_on      = false; // true;

var url_offline   = "offline/index_service.html";

// global variables
var handset       = new handset_class();
var frontend_urls = [frontend_url1, frontend_url2];

function onDeviceReady() {
	jslogit("begin onDeviceReady()");
	document.removeEventListener("deviceready", onDeviceReady);
	jslogit("onDeviceReady() removeEventListener done");
	try_load_window();
	jslogit("end onDeviceReady()");
}

function onLoad() {
	jslogit("begin onLoad()");
	if ( inbrowser() ) {
		jslogit("onLoad() if inbrowser() branch");
		try_load_window();
		return;
	}

	jslogit("onLoad() set up document.addEventListener deviceready");
	document.addEventListener("deviceready", onDeviceReady, false);
	jslogit("end onLoad()");
}

function handset_class() {
	this.get_qs = function() {
		var retqs =
			"?handset_guid="	+ get_handset_guid() +
			"&handset_counter="	+ get_handset_counter() +
			"&handset_installtime="	+ get_handset_installtime() +
			"&handset_installip="	+ get_handset_installip() +
			"&handset_brand="	+ get_handset_brand() +
			"&handset_os="		+ get_handset_os() +
			"&handset_version="	+ handset_version +
			'';
		return(retqs);
	}

	function get_handset_os() {
		try {
			if ( window._cordovaNative ) {
				return('android');
			} else {
				return('ios');
			}
		} catch(e) {
			return('na');
		}
	}

	function createGuid() {
		return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
			var r = Math.random()*16|0, v = c === 'x' ? r : (r&0x3|0x8);
			return v.toString(16);
		});
	}

	function get_handset_guid() {
		var handset_guid = localStorage.getItem('handset_guid');;
		if ( handset_guid === null ) {
			handset_guid = createGuid();
			localStorage.setItem('handset_guid', handset_guid);
		}
		return(handset_guid);
	}

	function get_handset_installtime() {
		var handset_installtime = localStorage.getItem('handset_installtime');
		if ( handset_installtime === null ) {
			handset_installtime = $.now();
			localStorage.setItem('handset_installtime', handset_installtime);
		}
		return(handset_installtime);
	}

	function get_handset_brand() {
		var handset_brand = localStorage.getItem('handset_brand');
		if ( handset_brand === null ) {
			handset_brand = '';
		}
		return(handset_brand);
	}

	this.set_handset_brand = function(brand) {
		localStorage.setItem('handset_brand', brand);
	}

	function get_handset_installip() {
		var handset_installip = localStorage.getItem('handset_installip');
		if ( handset_installip === null ) {
			handset_installip = '';
		}
		return(handset_installip);
	}

	// only set handset_installip if it was not set already
	this.set_handset_installip = function(ip) {
		var handset_installip = localStorage.getItem('handset_installip');
		if ( handset_installip === null ) {
			localStorage.setItem('handset_installip', ip);
		}
	}

	// only increment in it was not incremented already in this invocation
	var handset_counter_incremented = 0;
	function get_handset_counter() {
		var handset_counter = localStorage.getItem('handset_counter');
		if ( handset_counter === null ) {
			handset_counter = 0;
		}
		if ( ! handset_counter_incremented++ ) {
			handset_counter++;
			localStorage.setItem('handset_counter', handset_counter);
		}
		return(handset_counter);
	}
}

function try_load_window() {
	jslogit("begin try_load_window()");
	var baseurl = frontend_urls.shift();
	if ( ! baseurl ) {
		jslogit("try_load_window going local to "+url_offline);
		window.location.replace(url_offline);
		return;
	}

	var url = baseurl + "connection_detector.php" + handset.get_qs();
	jslogit("try_load_window("+baseurl+") url="+url);
	try {
		$.ajax({
			type:     "GET",
			url:      url,
			timeout:  5000, // in milliseconds
			dataType: "json"
			}).done(function(data) {
				jslogit("try_load_window() done start "+data['ip']);
				if ( data['ip'] ) {
					handset.set_handset_installip(data['ip']);
					handset.set_handset_brand(data['brand'])
					jslogit("try_load_window success");
					load_window(baseurl);
				}
				else {
					jslogit("try_load_window() repeat due to no ip");
					try_load_window();
				}
			}).fail(function(data) {
				jslogit("try_load_window() repeat due to fail");
				try_load_window();
			});
	} catch(e) {
		jslogit("try_load_window() repeat due to catch "+e.message).
		try_load_window();
	}
	jslogit("end try_load_window()");
}

function onBackButton(e) {
	jslogit("begin onBackButton()");
	e.preventDefault();
	navigator.app.exitApp();
	jslogit("end onBackButton()");
}

function recheck_connection() {
	var baseurl = frontend_url1;

	var url = baseurl + "connection_detector.php" + handset.get_qs();
	jslogit("begin recheck_connection("+baseurl+") url="+url);
	try {
		$.ajax({
			type:     "GET",
			url:      url,
			timeout:  5000, // in milliseconds
			dataType: "json"
			}).done(function(data) {
				jslogit("recheck_connection() done start "+data['ip']);
				if ( data['ip'] ) {
					handset.set_handset_installip(data['ip']);
					jslogit("recheck_connection success");
					document.removeEventListener("backbutton", onBackButton);
					load_window(baseurl);
				}
				else {
					jslogit("recheck_connection() repeat due to no ip");
					setTimeout(recheck_connection, 15000);
				}
			}).fail(function(data) {
				jslogit("recheck_connection() repeat due to fail");
				setTimeout(recheck_connection, 15000);
			});
	} catch(e) {
		jslogit("recheck_connection() repeat due to catch "+e.message).
		setTimeout(recheck_connection, 15000);
	}
	jslogit("end recheck_connection()");
}

function load_window_event_handler(event)
{
	jslogit("begin load_window_event_handler()");

	msg =	'type:' + event.type + '-' +
		'url:'  + event.url  + '-' +
		'code:' + event.code + '-' +
		'message:' + event.message;

	jslogit("load_window_event_handler " + msg);

	jslogit("end load_window_event_handler()");
}

function load_window(url) {
	jslogit("begin load_window(_self) "+url+handset.get_qs());
	var new_win = window.open(url+handset.get_qs(), "_self");

	new_win.addEventListener('loadstart', load_window_event_handler);
	new_win.addEventListener('loadstop',  load_window_event_handler);
	new_win.addEventListener('loaderror', load_window_event_handler);
	new_win.addEventListener('exit',      load_window_event_handler);

	jslogit("end load_window(_self) "+url+handset.get_qs());
}

function inbrowser() {
	jslogit("inbrowser() "+document.location.protocol);
	// this only works in the handset html files!!!
	if ( document.location.protocol === 'http:' ) {
		jslogit("inbrowser= 1");
		return(1);
	}
	jslogit("inbrowser= 0");
}

function jslogit(str) {
	if ( ! jslogit_on ) { return; }
	if ( typeof str !== 'string' ) { return; }

	// Check to see if the counter has been initialized
	if ( typeof jslogit.counter == 'undefined' ) {
		// It has not... perform the initialization
		jslogit.counter = 0;
	}
	jslogit.counter++;

	$.ajax({
		url: frontend_url1+'jslogit.php',
		data: { cnt: jslogit.counter, handset_jslogit: str }
	});
}

